Index: /LMDZ4/trunk/libf/dyn3d/bilan_dyn.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3d/bilan_dyn.F	(revision 540)
+++ /LMDZ4/trunk/libf/dyn3d/bilan_dyn.F	(revision 541)
@@ -2,7 +2,4 @@
 ! $Header$
 !
-c
-c $Header$
-c
       SUBROUTINE bilan_dyn (ntrac,dt_app,dt_cum,
      s  ps,masse,pk,flux_u,flux_v,teta,phi,ucov,vcov,trac)
Index: /LMDZ4/trunk/libf/dyn3d/conf_gcm.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3d/conf_gcm.F	(revision 540)
+++ /LMDZ4/trunk/libf/dyn3d/conf_gcm.F	(revision 541)
@@ -574,4 +574,12 @@
       ENDIF
 c
+!Config  Key  = offline
+!Config  Desc = Nouvelle eau liquide
+!Config  Def  = n
+!Config  Help = Permet de mettre en route la
+!Config         nouvelle parametrisation de l'eau liquide !
+       offline = .FALSE.
+       CALL getin('offline',offline)
+
 
       write(lunout,*)' #########################################'
@@ -615,4 +623,5 @@
       write(lunout,*)' tauxx = ', tauxx
       write(lunout,*)' tauyy = ', tauyy
+      write(lunout,*)' offline = ', offline
 
       RETURN
@@ -720,4 +729,13 @@
        CALL getin('ysinus',ysinus)
 c
+!Config  Key  = offline
+!Config  Desc = Nouvelle eau liquide
+!Config  Def  = n
+!Config  Help = Permet de mettre en route la
+!Config         nouvelle parametrisation de l'eau liquide !
+       offline = .FALSE.
+       CALL getin('offline',offline)
+      write(lunout,*)' offline = ', offline
+
 
       write(lunout,*)' #########################################'
@@ -761,4 +779,5 @@
       write(lunout,*)' taux = ', taux
       write(lunout,*)' tauy = ', tauy
+      write(lunout,*)' offline = ', offline
 c
       RETURN
Index: /LMDZ4/trunk/libf/dyn3d/control.h
===================================================================
--- /LMDZ4/trunk/libf/dyn3d/control.h	(revision 540)
+++ /LMDZ4/trunk/libf/dyn3d/control.h	(revision 541)
@@ -6,11 +6,12 @@
 
       COMMON/control/nday,day_step,
-     $              iperiod,iapp_tracvl,iconser,iecri,idissip,iphysiq ,
-     $              periodav,ecritphy,iecrimoy,dayref,anneeref,
-     $              raz_date
+     .              iperiod,iapp_tracvl,iconser,iecri,idissip,iphysiq ,
+     .              periodav,ecritphy,iecrimoy,dayref,anneeref,
+     .              raz_date,offline
 
       INTEGER   nday,day_step,iperiod,iapp_tracvl,iconser,iecri,
-     $          idissip,iphysiq,iecrimoy,dayref,anneeref, raz_date
+     .          idissip,iphysiq,iecrimoy,dayref,anneeref, raz_date
       REAL periodav, ecritphy
+      logical offline
 
 c-----------------------------------------------------------------------
Index: /LMDZ4/trunk/libf/dyn3d/dynetat0.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3d/dynetat0.F	(revision 540)
+++ /LMDZ4/trunk/libf/dyn3d/dynetat0.F	(revision 541)
@@ -106,8 +106,8 @@
       IF ( tab_cntrl(24).EQ.1. )  THEN
         fxyhypb  = . TRUE .
-        dzoomx   = tab_cntrl(25)
-        dzoomy   = tab_cntrl(26)
-        taux     = tab_cntrl(28)
-        tauy     = tab_cntrl(29)
+c        dzoomx   = tab_cntrl(25)
+c        dzoomy   = tab_cntrl(26)
+c        taux     = tab_cntrl(28)
+c        tauy     = tab_cntrl(29)
       ELSE
         fxyhypb = . FALSE .
Index: /LMDZ4/trunk/libf/dyn3d/dynredem.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3d/dynredem.F	(revision 540)
+++ /LMDZ4/trunk/libf/dyn3d/dynredem.F	(revision 541)
@@ -394,4 +394,5 @@
 #include "comgeom.h"
 #include "advtrac.h"
+#include "temps.h"
 
       INTEGER nq, l
@@ -406,4 +407,7 @@
       INTEGER ierr
       INTEGER iq
+      INTEGER length
+      PARAMETER (length = 100)
+      REAL tab_cntrl(length) ! tableau des parametres du run
       character*20 modname
       character*80 abort_message
@@ -435,4 +439,25 @@
 #endif
       PRINT*, "Enregistrement pour ", nb, time
+
+c
+c  Re-ecriture du tableau de controle, itaufin n'est plus defini quand
+c  on passe dans dynredem0
+      ierr = NF_INQ_VARID (nid, "controle", nvarid)
+      IF (ierr .NE. NF_NOERR) THEN
+         abort_message="dynredem1: Le champ <controle> est absent"
+         ierr = 1
+         CALL abort_gcm(modname,abort_message,ierr)
+      ENDIF
+#ifdef NC_DOUBLE
+      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, tab_cntrl)
+#else
+      ierr = NF_GET_VAR_REAL(nid, nvarid, tab_cntrl)
+#endif
+       tab_cntrl(31) = FLOAT(itau_dyn + itaufin)
+#ifdef NC_DOUBLE
+      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,tab_cntrl)
+#else
+      ierr = NF_PUT_VAR_REAL (nid,nvarid,tab_cntrl)
+#endif
 
 c  Ecriture des champs
Index: /LMDZ4/trunk/libf/dyn3d/fluxstokenc.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3d/fluxstokenc.F	(revision 541)
+++ /LMDZ4/trunk/libf/dyn3d/fluxstokenc.F	(revision 541)
@@ -0,0 +1,155 @@
+      SUBROUTINE fluxstokenc(pbaru,pbarv,masse,teta,phi,phis,
+     . time_step,itau )
+
+       USE IOIPSL
+c
+c     Auteur :  F. Hourdin
+c
+c
+ccc   ..   Modif. P. Le Van  ( 20/12/97 )  ...
+c
+      IMPLICIT NONE
+c
+#include "dimensions.h"
+#include "paramet.h"
+#include "comconst.h"
+#include "comvert.h"
+#include "comgeom.h"
+#include "tracstoke.h"
+#include "temps.h"
+
+      REAL time_step,t_wrt, t_ops
+      REAL pbaru(ip1jmp1,llm),pbarv(ip1jm,llm)
+      REAL masse(ip1jmp1,llm),teta(ip1jmp1,llm),phi(ip1jmp1,llm)
+      REAL phis(ip1jmp1)
+
+      REAL pbaruc(ip1jmp1,llm),pbarvc(ip1jm,llm)
+      REAL massem(ip1jmp1,llm),tetac(ip1jmp1,llm),phic(ip1jmp1,llm)
+
+      REAL pbarug(ip1jmp1,llm),pbarvg(iip1,jjm,llm),wg(ip1jmp1,llm)
+
+      REAL pbarvst(iip1,jjp1,llm),zistdyn
+	real dtcum
+
+      INTEGER iadvtr,ndex(1) 
+      integer nscal
+      real tst(1),ist(1),istp(1)
+      INTEGER ij,l,irec,i,j,itau
+      INTEGER fluxid, fluxvid,fluxdid
+ 
+      SAVE iadvtr, massem,pbaruc,pbarvc,irec
+      SAVE phic,tetac
+      logical first
+      save first
+      data first/.true./
+      DATA iadvtr/0/
+
+      if(first) then
+
+	CALL initfluxsto( 'fluxstoke',
+     .  time_step,istdyn* time_step,istdyn* time_step,
+     . nqmx, fluxid,fluxvid,fluxdid) 
+	
+	ndex(1) = 0
+        call histwrite(fluxid, 'phis', 1, phis, iip1*jjp1, ndex)
+        call histwrite(fluxid, 'aire', 1, aire, iip1*jjp1, ndex)
+	
+	ndex(1) = 0
+        nscal = 1
+        tst(1) = time_step
+        call histwrite(fluxdid, 'dtvr', 1, tst, nscal, ndex)
+        ist(1)=istdyn
+        call histwrite(fluxdid, 'istdyn', 1, ist, nscal, ndex)
+        istp(1)= istphy
+        call histwrite(fluxdid, 'istphy', 1, istp, nscal, ndex)
+	
+	first = .false.
+
+      endif
+
+
+      IF(iadvtr.EQ.0) THEN
+         CALL initial0(ijp1llm,phic)
+         CALL initial0(ijp1llm,tetac)
+         CALL initial0(ijp1llm,pbaruc)
+         CALL initial0(ijmllm,pbarvc)
+      ENDIF
+
+c   accumulation des flux de masse horizontaux
+      DO l=1,llm
+         DO ij = 1,ip1jmp1
+            pbaruc(ij,l) = pbaruc(ij,l) + pbaru(ij,l)
+            tetac(ij,l) = tetac(ij,l) + teta(ij,l)
+            phic(ij,l) = phic(ij,l) + phi(ij,l)
+         ENDDO
+         DO ij = 1,ip1jm
+            pbarvc(ij,l) = pbarvc(ij,l) + pbarv(ij,l)
+         ENDDO
+      ENDDO
+
+c   selection de la masse instantannee des mailles avant le transport.
+      IF(iadvtr.EQ.0) THEN
+         CALL SCOPY(ip1jmp1*llm,masse,1,massem,1)
+      ENDIF
+
+      iadvtr   = iadvtr+1
+
+
+c   Test pour savoir si on advecte a ce pas de temps
+      IF ( iadvtr.EQ.istdyn ) THEN
+c    normalisation
+      DO l=1,llm
+         DO ij = 1,ip1jmp1
+            pbaruc(ij,l) = pbaruc(ij,l)/float(istdyn)
+            tetac(ij,l) = tetac(ij,l)/float(istdyn)
+            phic(ij,l) = phic(ij,l)/float(istdyn)
+         ENDDO
+         DO ij = 1,ip1jm
+            pbarvc(ij,l) = pbarvc(ij,l)/float(istdyn)
+         ENDDO
+      ENDDO
+
+c   traitement des flux de masse avant advection.
+c     1. calcul de w
+c     2. groupement des mailles pres du pole.
+
+        CALL groupe( massem, pbaruc,pbarvc, pbarug,pbarvg,wg )
+
+        do l=1,llm
+           do j=1,jjm
+              do i=1,iip1
+                 pbarvst(i,j,l)=pbarvg(i,j,l)
+              enddo
+           enddo
+           do i=1,iip1
+              pbarvst(i,jjp1,l)=0.
+           enddo
+        enddo
+
+         iadvtr=0
+	Print*,'ITAU auqel on stoke les fluxmasses',itau
+	
+	call histwrite(fluxid, 'masse', itau, massem,
+     .               iip1*jjp1*llm, ndex)
+	
+	call histwrite(fluxid, 'pbaru', itau, pbarug,
+     .               iip1*jjp1*llm, ndex)
+	
+	call histwrite(fluxvid, 'pbarv', itau, pbarvg,
+     .               iip1*jjm*llm, ndex)
+	
+        call histwrite(fluxid, 'w' ,itau, wg, 
+     .             iip1*jjp1*llm, ndex) 
+	
+	call histwrite(fluxid, 'teta' ,itau, tetac, 
+     .             iip1*jjp1*llm, ndex) 
+	
+	call histwrite(fluxid, 'phi' ,itau, phic, 
+     .             iip1*jjp1*llm, ndex) 
+	
+C
+
+      ENDIF ! if iadvtr.EQ.istdyn
+
+      RETURN
+      END
Index: /LMDZ4/trunk/libf/dyn3d/gcm.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3d/gcm.F	(revision 540)
+++ /LMDZ4/trunk/libf/dyn3d/gcm.F	(revision 541)
@@ -56,6 +56,5 @@
 #include "com_io_dyn.h"
 #include "iniprint.h"
-
-c#include "tracstoke.h"
+#include "tracstoke.h"
 
 
@@ -118,7 +117,4 @@
 c-jld 
 
-
-      LOGICAL offline  ! Controle du stockage ds "fluxmass"
-      PARAMETER (offline=.false.)
 
       character*80 dynhist_file, dynhistave_file
@@ -368,4 +364,11 @@
 #endif
 
+c  Choix des frequences de stokage pour le offline
+c      istdyn=day_step/4     ! stockage toutes les 6h=1jour/4
+c      istdyn=day_step/12     ! stockage toutes les 2h=1jour/12
+      istdyn=day_step/4     ! stockage toutes les 6h=1jour/12
+      istphy=istdyn/iphysiq     
+
+
 c
 c-----------------------------------------------------------------------
Index: /LMDZ4/trunk/libf/dyn3d/leapfrog.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3d/leapfrog.F	(revision 540)
+++ /LMDZ4/trunk/libf/dyn3d/leapfrog.F	(revision 541)
@@ -149,7 +149,4 @@
 c-jld 
 
-      LOGICAL offline  ! Controle du stockage ds "fluxmass"
-      PARAMETER (offline=.false.)
-
       character*80 dynhist_file, dynhistave_file
       character*20 modname
@@ -199,6 +196,8 @@
 
 #ifdef CPP_IOIPSL
-      if (ok_guide) then
+      if (ok_guide.and.(itaufin-itau-1)*dtvr.gt.21600) then
         call guide(itau,ucov,vcov,teta,q,masse,ps)
+      else
+        print*,'attention on ne guide pas les 6 dernieres heures'
       endif
 #endif
@@ -289,6 +288,6 @@
 
 #ifdef CPP_IOIPSL
-c           CALL fluxstokenc(pbaru,pbarv,masse,teta,phi,phis,
-c    .   time_step, itau)
+           CALL fluxstokenc(pbaru,pbarv,masse,teta,phi,phis,
+     .   dtvr, itau)
 #endif
 
@@ -486,11 +485,11 @@
 
             IF( itau. EQ. itaufinp1 ) then  
-c      write(79,*) 'ucov',ucov
-c      write(80,*) 'vcov',vcov
-c      write(81,*) 'teta',teta
-c      write(82,*) 'ps',ps
-c      write(83,*) 'q',q
-c      WRITE(85,*) 'q1 = ',q(:,:,1)
-c      WRITE(86,*) 'q3 = ',q(:,:,3)
+       write(79,*) 'ucov',ucov
+       write(80,*) 'vcov',vcov
+       write(81,*) 'teta',teta
+       write(82,*) 'ps',ps
+       write(83,*) 'q',q
+       WRITE(85,*) 'q1 = ',q(:,:,1)
+       WRITE(86,*) 'q3 = ',q(:,:,3)
 
               abort_message = 'Simulation finished'
Index: /LMDZ4/trunk/libf/dyn3d/wrgrads.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3d/wrgrads.F	(revision 540)
+++ /LMDZ4/trunk/libf/dyn3d/wrgrads.F	(revision 541)
@@ -29,5 +29,5 @@
       writectl=.false.
 
-c     print*,if,iid(if),jid(if),ifd(if),jfd(if)
+      print*,if,iid(if),jid(if),ifd(if),jfd(if)
       iii=iid(if)
       iji=jid(if)
@@ -38,6 +38,6 @@
       lm=lmd(if)
 
-c      print*,'im,jm,lm,name,firsttime(if)'
-c      print*,im,jm,lm,name,firsttime(if)
+      print*,'im,jm,lm,name,firsttime(if)'
+      print*,im,jm,lm,name,firsttime(if)
 
       if(firsttime(if)) then
@@ -81,6 +81,6 @@
       endif
 
-c     print*,'ivar(if),nvar(if),var(ivar(if),if),writectl'
-c     print*,ivar(if),nvar(if),var(ivar(if),if),writectl
+      print*,'ivar(if),nvar(if),var(ivar(if),if),writectl'
+      print*,ivar(if),nvar(if),var(ivar(if),if),writectl
       do l=1,nl
          irec(if)=irec(if)+1
Index: /LMDZ4/trunk/libf/phylmd/FCTTRE.inc
===================================================================
--- /LMDZ4/trunk/libf/phylmd/FCTTRE.inc	(revision 540)
+++ /LMDZ4/trunk/libf/phylmd/FCTTRE.inc	(revision 541)
@@ -16,5 +16,6 @@
 !
       FOEEW ( PTARG,PDELARG ) = EXP ( &
-     &          (R3LES*(1.-PDELARG)+R3IES*PDELARG) * (PTARG-RTT) &
+!    &          (R3LES*(1.-PDELARG)+R3IES*PDELARG) * (PTARG-TEST_RTT) &
+     &          (R3LES*(1.-PDELARG)+R3IES*PDELARG) * (PTARG-273.16) &
      & / (PTARG-(R4LES*(1.-PDELARG)+R4IES*PDELARG)) )
 !
@@ -31,8 +32,10 @@
      &           + 25.21935 * EXP( - 2999.924 / ptarg))
 !
-      dqsats(ptarg,pqsarg) = RLVTT/RCPD*pqsarg * (3.56654/ptarg &
+!      dqsats(ptarg,pqsarg) = TEST_RLVTT/TEST_RCPD*pqsarg * (3.56654/ptarg &
+      dqsats(ptarg,pqsarg) = 0.2500800E+07/0.1004709E+04*pqsarg * (3.56654/ptarg &
      &                     +2484.896*LOG(10.)/ptarg**2 &
      &                     -0.00320991*LOG(10.))
-      dqsatl(ptarg,pqsarg) = RLVTT/RCPD*pqsarg*LOG(10.)* &
+!     dqsatl(ptarg,pqsarg) = TEST_RLVTT/TEST_RCPD*pqsarg*LOG(10.)* &
+      dqsatl(ptarg,pqsarg) = 0.2500800E+07/0.1004709E+04*pqsarg*LOG(10.)* &
      &                (2948.964/ptarg**2-5.028/LOG(10.)/ptarg &
      &                +25.21935*2999.924/ptarg**2*EXP(-2999.924/ptarg) &
Index: /LMDZ4/trunk/libf/phylmd/calltherm.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/calltherm.F	(revision 541)
+++ /LMDZ4/trunk/libf/phylmd/calltherm.F	(revision 541)
@@ -0,0 +1,116 @@
+!
+! $Header$
+!
+      subroutine calltherm(dtime
+     s      ,pplay,paprs,pphi
+     s      ,u_seri,v_seri,t_seri,q_seri
+     s      ,d_u_ajs,d_v_ajs,d_t_ajs,d_q_ajs
+     s      ,fm_therm,entr_therm)
+
+      implicit none
+#include "dimensions.h"
+#include "dimphy.h"
+#include "thermcell.h"
+
+c  A inclure eventuellement dans les fichiers de configuration
+      data r_aspect_thermals,l_mix_thermals,tho_thermals/4.,10.,0./
+      data w2di_thermals/0/
+
+      REAL dtime
+
+      REAL u_seri(klon,klev),v_seri(klon,klev)
+      REAL t_seri(klon,klev),q_seri(klon,klev)
+      REAL paprs(klon,klev+1)
+      REAL pplay(klon,klev)
+      REAL pphi(klon,klev)
+
+CFH Update Thermiques
+      REAL d_t_ajs(klon,klev), d_q_ajs(klon,klev)
+      REAL d_u_ajs(klon,klev),d_v_ajs(klon,klev)
+      real fm_therm(klon,klev+1),entr_therm(klon,klev)
+
+
+c variables locales
+      REAL d_t_the(klon,klev), d_q_the(klon,klev)
+      REAL d_u_the(klon,klev),d_v_the(klon,klev)
+c
+      real zfm_therm(klon,klev+1),zentr_therm(klon,klev),zdt
+      save zentr_therm,zfm_therm
+
+      integer i,k
+
+*********************************************************
+
+c  Modele du thermique
+c  ===================
+c         print*,'thermiques: WARNING on passe t au lieu de t_seri'
+       print*,'avant isplit ',nsplit_thermals
+
+
+         fm_therm(:,:)=0.
+         entr_therm(:,:)=0.
+
+c   tests sur les valeurs negatives de l'eau
+         do k=1,klev
+            do i=1,klon
+               if (.not.q_seri(i,k).ge.0.) then
+                   print*,'WARN eau<0 avant therm i=',i,'  k=',k
+     s         ,' dq,q',d_q_the(i,k),q_seri(i,k)
+                  q_seri(i,k)=1.e-15
+               endif
+            enddo
+         enddo
+
+
+         zdt=dtime/float(nsplit_thermals)
+         do isplit=1,nsplit_thermals
+
+            CALL thermcell(klon,klev,zdt
+     s      ,pplay,paprs,pphi
+     s      ,u_seri,v_seri,t_seri,q_seri
+     s      ,d_u_the,d_v_the,d_t_the,d_q_the
+     s      ,zfm_therm,zentr_therm
+     s      ,r_aspect_thermals,l_mix_thermals,w2di_thermals
+     s      ,tho_thermals,3)
+
+c  transformation de la derivee en tendance
+            d_t_the(:,:)=d_t_the(:,:)*dtime/float(nsplit_thermals)
+            d_u_the(:,:)=d_u_the(:,:)*dtime/float(nsplit_thermals)
+            d_v_the(:,:)=d_v_the(:,:)*dtime/float(nsplit_thermals)
+            d_q_the(:,:)=d_q_the(:,:)*dtime/float(nsplit_thermals)
+            fm_therm(:,:)=fm_therm(:,:)
+     s      +zfm_therm(:,:)/float(nsplit_thermals)
+            entr_therm(:,:)=entr_therm(:,:)
+     s       +zentr_therm(:,:)/float(nsplit_thermals)
+            fm_therm(:,klev+1)=0.
+
+
+
+c  accumulation de la tendance
+            d_t_ajs(:,:)=d_t_ajs(:,:)+d_t_the(:,:)
+            d_u_ajs(:,:)=d_u_ajs(:,:)+d_u_the(:,:)
+            d_v_ajs(:,:)=d_v_ajs(:,:)+d_v_the(:,:)
+            d_q_ajs(:,:)=d_q_ajs(:,:)+d_q_the(:,:)
+
+c  incrementation des variables meteo
+            t_seri(:,:) = t_seri(:,:) + d_t_the(:,:)
+            u_seri(:,:) = u_seri(:,:) + d_u_the(:,:)
+            v_seri(:,:) = v_seri(:,:) + d_v_the(:,:)
+            q_seri(:,:) = q_seri(:,:) + d_q_the(:,:)
+
+c   tests sur les valeurs negatives de l'eau
+            DO k = 1, klev
+            DO i = 1, klon
+               if (.not.q_seri(i,k).ge.0.) then
+                   print*,'WARN eau<0 apres therm i=',i,'  k=',k
+     s         ,' dq,q',d_q_the(i,k),q_seri(i,k)
+                  q_seri(i,k)=1.e-15
+               endif
+            ENDDO
+            ENDDO
+
+         enddo ! isplit
+
+      return
+
+      end
Index: /LMDZ4/trunk/libf/phylmd/clmain.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/clmain.F	(revision 540)
+++ /LMDZ4/trunk/libf/phylmd/clmain.F	(revision 541)
@@ -17,6 +17,6 @@
      .                  d_t,d_q,d_u,d_v,d_ts,
      .                  flux_t,flux_q,flux_u,flux_v,cdragh,cdragm,
+     .                  q2,
      .                  dflux_t,dflux_q,
-cIM cf JLD    .                  zcoefh,zu1,zv1, t2m, q2m, u10m, v10m)
      .                  zcoefh,zu1,zv1, t2m, q2m, u10m, v10m,
      .                  fqcalving,ffonte, run_off_lic_0)
@@ -89,4 +89,5 @@
 #include "dimsoil.h"
 #include "iniprint.h"
+#include "compbl.h"
 c
       REAL dtime
@@ -183,10 +184,20 @@
 cAA      REAL yflxsrf(klon,nbtr)
 c
-      LOGICAL contreg
-      PARAMETER (contreg=.TRUE.)
 c
       LOGICAL ok_nonloc
       PARAMETER (ok_nonloc=.FALSE.)
       REAL ycoefm0(klon,klev), ycoefh0(klon,klev)
+
+      real yzlay(klon,klev),yzlev(klon,klev+1),yteta(klon,klev)
+      real ykmm(klon,klev+1),ykmn(klon,klev+1)
+      real ykmq(klon,klev+1)
+      real yq2(klon,klev+1),q2(klon,klev+1,nbsrf)
+      real q2diag(klon,klev+1)
+      real yustar(klon),y_cd_m(klon),y_cd_h(klon)
+
+
+
+
+
 c
 #include "YOMCST.h"
@@ -220,5 +231,5 @@
       LOGICAL first_appel
       SAVE first_appel
-      DATA first_appel/.false./
+      DATA first_appel/.true./
       LOGICAL debugindex
       SAVE debugindex
@@ -254,5 +265,5 @@
       endif
       IF (first_appel) THEN
-          first_appel=.false.
+!          first_appel=.false.
 !
 ! initialisation sorties netcdf
@@ -479,5 +490,12 @@
 c
 c
+cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 c calculer Cdrag et les coefficients d'echange
+cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+
+cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+c  Calcul anciens du LMD. Effectues de toutes facons.
+cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+
       CALL coefkz(nsrf, knon, ypaprs, ypplay,
 cIM 261103
@@ -487,6 +505,25 @@
      .            yqsurf, 
      .            ycoefm, ycoefh)
+
       CALL coefkz2(nsrf, knon, ypaprs, ypplay,yt,
      .                  ycoefm0, ycoefh0)
+      if (first_appel) then
+        if (prt_level > 9) THEN
+          WRITE(lunout,*)'Apres coefkz2 '
+          WRITE(lunout,*)'nsrf,knon,yts,yrugos,yqsurf',
+     .    nsrf,knon,yts,yrugos,yqsurf
+          WRITE(lunout,*)'ypaprs(1,k),ypplay(1,k),yu,yv,yt'
+          do k=1,klev
+            WRITE(lunout,*)ypaprs(1,k),ypplay(1,k),
+     .      yu(1,k),yv(1,k),yt(1,k)
+          enddo
+          do k=1,klev
+            WRITE(lunout,*)ycoefm(1,k),ycoefh(1,k),
+     .      ycoefm0(1,k),ycoefh0(1,k)
+          enddo
+        ENDIF
+        first_appel=.false.
+      endif
+
       DO k = 1, klev
       DO i = 1, knon
@@ -495,4 +532,5 @@
       ENDDO
       ENDDO
+
 c
 cIM cf JLD : on seuille ycoefm et ycoefh
@@ -528,6 +566,78 @@
 cIM: 261103
 
-c
+
+      IF (iflag_pbl.ge.3) then
+
+cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+c MELLOR ET YAMADA adapte a Mars Richard Fournier et Frederic Hourdin
+cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+
+         yzlay(1:knon,1)=
+     .   RD*yt(1:knon,1)/(0.5*(ypaprs(1:knon,1)+ypplay(1:knon,1)))
+     .   *(ypaprs(1:knon,1)-ypplay(1:knon,1))/RG
+         do k=2,klev
+            yzlay(1:knon,k)=
+     .      yzlay(1:knon,k-1)+RD*0.5*(yt(1:knon,k-1)+yt(1:knon,k))
+     .      /ypaprs(1:knon,k)*(ypplay(1:knon,k-1)-ypplay(1:knon,k))/RG
+         enddo
+         do k=1,klev
+            yteta(1:knon,k)=
+     .      yt(1:knon,k)*(ypaprs(1:knon,1)/ypplay(1:knon,k))**rkappa
+     .      *(1.+0.61*yq(1:knon,k))
+         enddo
+         yzlev(1:knon,1)=0.
+         yzlev(1:knon,klev+1)=2.*yzlay(1:knon,klev)-yzlay(1:knon,klev-1)
+         do k=2,klev
+            yzlev(1:knon,k)=0.5*(yzlay(1:knon,k)+yzlay(1:knon,k-1))
+         enddo
+         DO k = 1, klev+1
+            DO j = 1, knon
+               i = ni(j)
+               yq2(j,k)=q2(i,k,nsrf)
+            enddo
+         enddo
+
+
+c   Bug introduit volontairement pour converger avec les resultats
+c  du papier sur les thermiques.
+         if (1.eq.1) then
+         y_cd_m(1:knon) = ycoefm(1:knon,1)
+         y_cd_h(1:knon) = ycoefh(1:knon,1)
+         else
+         y_cd_h(1:knon) = ycoefm(1:knon,1)
+         y_cd_m(1:knon) = ycoefh(1:knon,1)
+         endif
+         call ustarhb(knon,yu,yv,y_cd_m, yustar)
+
+        if (prt_level > 9) THEN
+          WRITE(lunout,*)'USTAR = ',yustar
+        ENDIF
+
+c   iflag_pbl peut etre utilise comme longuer de melange
+
+         if (iflag_pbl.ge.11) then
+            call vdif_kcay(knon,dtime,rg,rd,ypaprs,yt
+     s      ,yzlev,yzlay,yu,yv,yteta
+     s      ,y_cd_m,yq2,q2diag,ykmm,ykmn,yustar,
+     s      iflag_pbl)
+         else
+            call yamada4(knon,dtime,rg,rd,ypaprs,yt
+     s      ,yzlev,yzlay,yu,yv,yteta
+     s      ,y_cd_m,yq2,ykmm,ykmn,ykmq,yustar,
+     s      iflag_pbl)
+         endif
+
+         ycoefm(1:knon,1)=y_cd_m(1:knon)
+         ycoefh(1:knon,1)=y_cd_h(1:knon)
+         ycoefm(1:knon,2:klev)=ykmm(1:knon,2:klev)
+         ycoefh(1:knon,2:klev)=ykmn(1:knon,2:klev)
+
+
+      ENDIF
+
+cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 c calculer la diffusion des vitesses "u" et "v"
+cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+
       CALL clvent(knon,dtime,yu1,yv1,ycoefm,yt,yu,ypaprs,ypplay,ydelp,
      s            y_d_u,y_flux_u)
@@ -545,5 +655,7 @@
 c$$$      enddo
 
+cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 c calculer la diffusion de "q" et de "h"
+cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
       CALL clqh(dtime, itap, date0,jour, debut,lafin,
      e          rlon, rlat, cufi, cvfi,
@@ -560,5 +672,4 @@
      s          pctsrf_new, yagesno,
      s          y_d_t, y_d_q, y_d_ts, yz0_new,
-cIM cf JLD    s          y_flux_t, y_flux_q, y_dflux_t, y_dflux_q)
      s          y_flux_t, y_flux_q, y_dflux_t, y_dflux_q,
      s          y_fqcalving,y_ffonte,y_run_off_lic_0)
@@ -699,23 +810,4 @@
 c
         qairsol(j) = yqsurf(j)
-c$$$        IF (nsrf.EQ.1) THEN
-c$$$          qairsol(j) = yqsurf(j)
-c$$$        ELSE IF(nsrf.GT.1) THEN
-c$$$         zt = ts(i,nsrf)
-c$$$         IF (thermcep) THEN
-c$$$           zdelta = MAX(0.,SIGN(1.,RTT-zt))
-c$$$           zqs = R2ES * FOEEW(zt,zdelta) / ypplay(j,1)
-c$$$           zqs = MIN(0.5,zqs)
-c$$$           zcor = 1./(1.-RETV*zqs)
-c$$$           zqs = zqs*zcor
-c$$$         ELSE
-c$$$           IF (zt .LT. t_coup) THEN
-c$$$             zqs = qsats(zt) / ypplay(j,1)
-c$$$           ELSE
-c$$$             zqs = qsatl(zt) / ypplay(j,1)
-c$$$           ENDIF
-c$$$         ENDIF   
-c$$$         qairsol(j) = zqs
-c$$$        ENDIF   
       ENDDO
 c
@@ -778,4 +870,13 @@
        ENDDO 
 #endif
+
+      do j=1,knon
+         do k=1,klev+1
+         i=ni(j)
+         q2(i,k,nsrf)=yq2(j,k)
+         enddo
+      enddo
+c
+
 99999 CONTINUE
 c
@@ -802,5 +903,4 @@
      s                pctsrf_new, agesno,
      s                d_t, d_q, d_ts, z0_new, 
-cIM cf JLD    s                flux_t, flux_q,dflux_s,dflux_l)
      s                flux_t, flux_q,dflux_s,dflux_l,
      s                fqcalving,ffonte,run_off_lic_0)
@@ -820,4 +920,5 @@
 #include "indicesol.h"
 #include "dimsoil.h"
+#include "iniprint.h"
 
 c Arguments:
@@ -901,6 +1002,5 @@
       REAL zdelz
 c======================================================================
-      logical contreg
-      parameter (contreg=.true.)
+#include "compbl.h"
 c======================================================================
 c Rajout pour l'interface
@@ -944,12 +1044,6 @@
       ENDIF
 C
-      if (.not. contreg) then
-        do k = 2, klev
-          do i = 1, knon
-            gamq(i,k) = 0.0
-            gamt(i,k) = 0.0
-          enddo
-        enddo
-      else
+C
+      if (iflag_pbl.eq.1) then
         do k = 3, klev
           do i = 1, knon
@@ -961,4 +1055,11 @@
           gamq(i,2) = 0.0
           gamt(i,2) = -2.5e-03
+        enddo
+      else
+        do k = 2, klev
+          do i = 1, knon
+            gamq(i,k) = 0.0
+            gamt(i,k) = 0.0
+          enddo
         enddo
       endif
@@ -1089,5 +1190,4 @@
      s evap, fluxsens, fluxlat, dflux_l, dflux_s,              
      s tsol_rad, tsurf_new, alb_new, alblw, emis_new, z0_new, 
-cIM cf JLD    s pctsrf_new, agesno)
      s pctsrf_new, agesno,fqcalving,ffonte, run_off_lic_0)
 
@@ -1162,4 +1262,5 @@
 #include "dimensions.h"
 #include "dimphy.h"
+#include "iniprint.h"
       INTEGER knon
       REAL dtime
@@ -1288,4 +1389,5 @@
 #include "YOMCST.h"
 #include "indicesol.h"
+#include "iniprint.h"
 c
 c Arguments:
@@ -1335,6 +1437,6 @@
       LOGICAL opt_ec ! formule du Centre Europeen dans l'atmosphere
       PARAMETER (opt_ec=.FALSE.)
-      LOGICAL contreg ! utiliser le contre-gradient dans Ri
-      PARAMETER (contreg=.TRUE.)
+
+#include "compbl.h"
 c
 c Variables locales:
@@ -1379,10 +1481,12 @@
 c
       IF (appel1er) THEN
-         PRINT*, 'coefkz, opt_ec:', opt_ec
-         PRINT*, 'coefkz, richum:', richum
-         IF (richum) PRINT*, 'coefkz, ratqs:', ratqs
-         PRINT*, 'coefkz, isommet:', isommet
-         PRINT*, 'coefkz, tvirtu:', tvirtu
-         appel1er = .FALSE.
+        if (prt_level > 9) THEN
+          WRITE(lunout,*)'coefkz, opt_ec:', opt_ec
+          WRITE(lunout,*)'coefkz, richum:', richum
+          IF (richum) WRITE(lunout,*)'coefkz, ratqs:', ratqs
+          WRITE(lunout,*)'coefkz, isommet:', isommet
+          WRITE(lunout,*)'coefkz, tvirtu:', tvirtu
+          appel1er = .FALSE.
+        endif
       ENDIF
 c
@@ -1399,22 +1503,16 @@
       ENDDO
 
-c$$$      IF(nsrf.NE.1) THEN
-c$$$      do i = 1, knon
-c$$$        qsurf(i) = qsatl(ts(i))/paprs(i,1)
-c$$$      enddo
-c$$$      ENDIF
-
 c
 c Prescrire la valeur de contre-gradient
 c
-      IF (.NOT.contreg) THEN
-         DO k = 2, klev
-            gamt(k) = 0.0
-         ENDDO
-      ELSE
+      if (iflag_pbl.eq.1) then
          DO k = 3, klev
             gamt(k) = -1.0E-03
          ENDDO
          gamt(2) = -2.5E-03
+      else
+         DO k = 2, klev
+            gamt(k) = 0.0
+         ENDDO
       ENDIF
 cIM cf JLD/ GKtest
@@ -1469,7 +1567,4 @@
       ENDDO
 
-      IF (check) THEN
-      PRINT*,' isommet=',isommet,' knon=',knon
-      ENDIF
 
       DO k = 2, isommet
@@ -1608,4 +1703,5 @@
 #include "YOMCST.h"
 #include "indicesol.h"
+#include "iniprint.h"
 c
 c Arguments:
@@ -1702,4 +1798,5 @@
 #include "YOMCST.h"
 #include "indicesol.h"
+#include "iniprint.h"
       REAL tau_gl ! temps de relaxation pour la glace de mer
 ccc      PARAMETER (tau_gl=86400.0*30.0)
@@ -1783,4 +1880,5 @@
 #include "dimphy.h"
 #include "YOMCST.h"
+#include "iniprint.h"
 c
 c Arguments:
Index: /LMDZ4/trunk/libf/phylmd/conf_phys.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/conf_phys.F90	(revision 540)
+++ /LMDZ4/trunk/libf/phylmd/conf_phys.F90	(revision 541)
@@ -9,5 +9,6 @@
  &                     ratqsbas,ratqshaut,if_ebil, &
  &		       ok_ade, ok_aie, &
- &                     bl95_b0, bl95_b1)
+ &                     bl95_b0, bl95_b1,&
+ &                     iflag_thermals,nsplit_thermals)
 
    use IOIPSL
@@ -19,5 +20,6 @@
 #include "YOMCST.inc"
 !IM : on inclut/initialise les taux de CH4, N2O, CFC11 et CFC12
-#include "clesphys.inc"
+include "clesphys.inc"
+include "compbl.h"
 !
 ! Configuration de la "physique" de LMDZ a l'aide de la fonction
@@ -51,4 +53,5 @@
   real                 :: zzz
 
+  integer :: iflag_thermals,nsplit_thermals
 !
 !
@@ -514,4 +517,35 @@
   ok_kzmin = .true.
   call getin('ok_kzmin',ok_kzmin)
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+! PARAMETER FOR THE PLANETARY BOUNDARY LAYER
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+!Config Key  = iflag_pbl
+!Config Desc =
+!Config Def  = 1
+!Config Help =
+!
+  iflag_pbl = 1
+  call getin('iflag_pbl',iflag_pbl)
+!
+!Config Key  = iflag_thermals
+!Config Desc =
+!Config Def  = 0
+!Config Help =
+!
+  iflag_thermals = 0
+  call getin('iflag_thermals',iflag_thermals)
+!
+!
+!Config Key  = nsplit_thermals
+!Config Desc =
+!Config Def  = 1
+!Config Help =
+!
+  nsplit_thermals = 1
+  call getin('nsplit_thermals',nsplit_thermals)
+
+
 
 !
@@ -606,4 +640,6 @@
   write(numout,*)' lev_histday = ',lev_histday 
   write(numout,*)' lev_histmth = ',lev_histmth 
+  write(numout,*)' iflag_pbl = ', iflag_pbl
+  write(numout,*)' iflag_thermals = ', iflag_thermals
 
   return
Index: /LMDZ4/trunk/libf/phylmd/initphysto.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/initphysto.F	(revision 540)
+++ /LMDZ4/trunk/libf/phylmd/initphysto.F	(revision 541)
@@ -188,7 +188,17 @@
 c coefh frac_impa,frac_nucl
 	
-	call histdef(fileid, 'coefh', ' ', ' ',
-     .             iim, jjm+1, nhoriid, llm, 1, llm, zvertiid,
-     .             32, 'inst(X)', t_ops, t_wrt)
+	call histdef(fileid, "coefh", " ", " ",
+     .             iim, jjm+1, nhoriid, llm, 1, llm, zvertiid,
+     .             32, "inst(X)", t_ops, t_wrt)
+
+c abderrahmane le 16 09 02
+        call histdef(fileid, "fm_th", " ", " ",
+     .             iim, jjm+1, nhoriid, llm, 1, llm, zvertiid,
+     .             32, "inst(X)", t_ops, t_wrt)
+
+        call histdef(fileid, "en_th", " ", " ",
+     .             iim, jjm+1, nhoriid, llm, 1, llm, zvertiid,
+     .             32, "inst(X)", t_ops, t_wrt)
+c fin aj
 	
 	write(*,*) 'apres coefh ds initphysto'	
@@ -283,5 +293,6 @@
 
       call histend(fileid)
-      if (ok_sync) call histsync(fileid)
+c     if (ok_sync) call histsync(fileid)
+      if (ok_sync) call histsync
 
 	
Index: /LMDZ4/trunk/libf/phylmd/initrrnpb.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/initrrnpb.F	(revision 540)
+++ /LMDZ4/trunk/libf/phylmd/initrrnpb.F	(revision 541)
@@ -74,6 +74,4 @@
       DO i = 1,klon
         masktr(i,it) = 0.
-c       IF ( NINT(pctsrf(i,3)) .EQ. 1 ) masktr(i,it) = 1.
-c       fshtr(i,it) = s * masktr(i,it) * pctsrf(i,3)
         IF ( NINT(pctsrf(i,1)) .EQ. 1 ) masktr(i,it) = 1.
         fshtr(i,it) = s * masktr(i,it)
